#include <linux/module.h>
#include <linux/sched.h>
#include <linux/init.h>
#include "../mach-mv88fxx81/mv88f5181/mvSysHwConfig.h" 

#define MV_ARM_32BIT_LE(X) (X)

static int __init ticker_init(void);
static void __exit ticker_exit(void);

MODULE_AUTHOR("Anonymous");
MODULE_LICENSE("Proprietary");
MODULE_SUPPORTED_DEVICE("Marvell Orion 5181/5181L");

#define CPU_RSTOUTN_MASK_REG			0x20108
#define CPU_SYS_SOFT_RST_REG            0x2010C
#define MV_ARM_32BIT_LE(X) (X)
#define FQ2SEC 133333333
static int inSec = 12; 
typedef struct timer_list Timer;
static Timer Ticker;

int force_to_reboot=0;
extern unsigned short mv_gtw_read_switch_reg(unsigned char port, unsigned char reg);

static int mv_watchdog_init(void)
{
	volatile unsigned int temp;
	
	//Clear watchdog int.
	*(volatile unsigned int*)(INTER_REGS_BASE + 0x20110) = MV_ARM_32BIT_LE(0);
	//Set timer in Second.
	*(volatile unsigned int*)(INTER_REGS_BASE + 0x20324) = MV_ARM_32BIT_LE(inSec * FQ2SEC);
	//Enable watchdog.
	temp = *(volatile unsigned int*)(INTER_REGS_BASE + CPU_RSTOUTN_MASK_REG);
	temp |= MV_ARM_32BIT_LE(0x02);
	*(volatile unsigned int*)(INTER_REGS_BASE + CPU_RSTOUTN_MASK_REG) = temp;
	printk("<0>""WatchDog enabled.\n");
	

    return 0;
}

void cbkF (void)
{
    
    if ( (0xa7!= mv_gtw_read_switch_reg(0, 0x4)) &&
         (0x17aa!= mv_gtw_read_switch_reg(0, 0x6)) && 
         (0xc3!= mv_gtw_read_switch_reg(0, 0x8))
         )
    {
        printk("<0>""port 0 reg 0x4: 0x%x\n",mv_gtw_read_switch_reg(0, 0x4));
        printk("<0>""port 0 reg 0x6: 0x%x\n",mv_gtw_read_switch_reg(0, 0x6));
        printk("<0>""port 0 reg 0x8: 0x%x\n",mv_gtw_read_switch_reg(0, 0x8));
        printk("<0>""prepare to reset switch \n");
        return;
    }
    
    if ( force_to_reboot == 1 )
    {
        printk("<0>""force to reboot system\n");
        return;
    }
	*(volatile unsigned int*)(INTER_REGS_BASE + 0x20324) = MV_ARM_32BIT_LE(inSec * FQ2SEC); 
	Ticker.expires = jiffies + 3* HZ;    
    add_timer(&Ticker);
}	

static void __exit ticker_exit(void)
{
}

static int __init ticker_init(void)
{
	init_timer(&Ticker);
	Ticker.function = cbkF;
    Ticker.data = (unsigned int) NULL;
    Ticker.expires = jiffies + HZ;    
    add_timer(&Ticker);
    
    mv_watchdog_init();
    return 0;
}

module_init(ticker_init);
module_exit(ticker_exit);